classdef fun_circulacion
    methods (Static)       
        % Funciones de red rectangular NxM
        function [G, p]=plot_meshR(K,init)
            N=init.N;
            M=init.M;
            
% % % %             % desconecto iterativamente los nodos que tienen corriente media inyectada nula
% % % %             cont=1; %para entrar al menos una vez
% % % %             while cont>0 %si no encontre ninguno, salgo
% % % %                 index=find(init.meancurrs==0);%recorro todos los nodos que no tienen corriente inyectada
% % % %                 cont=0;
% % % %                 for i=1:length(index)
% % % %                     if sum(K(index(i),:)>0)==1 % si solo tienen un cable conectado, los desconecto
% % % %                         K(index(i),:)=0;
% % % %                         K(:,index(i))=0;
% % % %                         cont=cont+1;
% % % %                     end
% % % %                 end
% % % %             end
            
            %desconecto los K menores que un umbral. y eligo el umbral para que todos
            %los nodos sumideros queden conectados:
            %-para cada nodo sumidero, busco la conexion maxima. 
            %-me quedo con el minimo de esos de todos los nodos. 
            %-lo divido por 1.1, por las fluctuaciones...
            index=(init.meancurrs~=0);%todos los sumideros (tejido, los que tienen corriente media no nula)
            kmax=full(max(K(index,:),[],2));            
            umbral=min(kmax)/1.1;
            K(K<umbral)=0;
            
            G=graph(K,'upper');
            G.Edges.LWidths = 10*G.Edges.Weight/max(G.Edges.Weight);
            [posx,posy]=ind2sub([N M],1:N*M);
            p=plot(G, 'XData', posx, 'YData', posy);
%             p=plot(G, 'XData', posx, 'YData', posy,'LineWidth',G.Edges.LWidths,'layout','force');
%                 p=plot(G, 'XData', posx, 'YData', posy,'LineWidth',G.Edges.LWidths);
%                 p=plot(G,'layout','force','iterations',1);
%                 p.XData=posx;
%                 p.YData=posy;
            p.LineWidth = G.Edges.LWidths;%esto es muy lento, no se por que.
            p.NodeLabel=[];
            p.MarkerSize=1;
            p.Marker='none';
            p.EdgeColor='r';
            
%             str=sprintf('\\Sigma I_{ij}^2/\\kappa_{ij}=%2.3f',log10(fun_circulacion.potenciadisipadaR(init))); %me falta init.I2
%             title(str)
            axis equal            
        end                
        function [K,D]=KRedCuadradaDiagonalesR(init)
            N=init.N;
            M=init.M;
            N2=N*M;
            gamma=init.gamma;
            
            % Conectividad a primeros vecinos (inicia random)...
            K = zeros(N2,N2);   %conductancias
            D = zeros(N2,N2);   %primeros vecinos
            for nodo=1:N2
                for vec=nodo+1:N2 
                    [inod,jnod]=ind2sub([N,M],nodo); %indices nodo
                    [ivec,jvec]=ind2sub([N,M],vec);  %indices vecino
                    if abs(ivec-inod)==1 && abs(jvec-jnod)==0
                        K(nodo,vec)=rand;
                        D(nodo,vec)=1;
                    end
                    if abs(ivec-inod)==0 && abs(jvec-jnod)==1
                        K(nodo,vec)=rand;
                        D(nodo,vec)=1;
                    end
                    if abs(ivec-inod)==1 && abs(jvec-jnod)==1
                        K(nodo,vec)=rand;
                        D(nodo,vec)=sqrt(2);
                    end                    
                end
            end
            % ... y simetrica (K_ij=K_ji)
            K=triu(K)+triu(K)'-diag(diag(K)); %GROSO!
            D=triu(D)+triu(D)'-diag(diag(D)); %primeros vecinos   
            
            %normalizo K para que sum(k^gamma) sea N^2
            K=K.*(N2/sum(K(:).^gamma))^(1/gamma); 
        end         
        function [K,D]=KPrimerosVecinosR(init)
            N=init.N;
            M=init.M;
            N2=N*M;
            gamma=init.gamma;
            
            % Conectividad a primeros vecinos (inicia random)...
            if ~isfield(init,'K') | ~isfield(init,'D')                
                K = zeros(N2,N2);   %conductancias
                D = zeros(N2,N2);   %primeros vecinos
                for nodo=1:N2
                    for vec=nodo:N2 
                        [inod,jnod]=ind2sub([N,M],nodo); %indices nodo
                        [ivec,jvec]=ind2sub([N,M],vec);  %indices vecino
                        if ((ivec==inod && abs(jvec-jnod)==1) || (jvec==jnod && abs(ivec-inod)==1))
                            K(nodo,vec)=rand;
                            %si aca algunos son cero, ya no varian
                            D(nodo,vec)=1;%primeros vecinos
                        end
                    end
                end
            else
                K = zeros(N2,N2);   %conductancias
                D = init.D;
                K(D==1)=rand(sum(sum(D==1)),1);                
            end
            % ... y simetrica (K_ij=K_ji)
            K=triu(K)+triu(K)'-diag(diag(K)); %GROSO!
            D=triu(D)+triu(D)'-diag(diag(D)); %primeros vecinos  
            
            %normalizo K para que sum(k^gamma) sea N^2
            K=K.*(N2/sum(K(:).^gamma))^(1/gamma);            
        end 
        function [K,D]=KPorLosBordes(init)
            N=init.N;
            M=init.M;
            N2=N*M;
            I=init.I;
            gamma=init.gamma;
            
            % Conectividad a primeros vecinos (inicia random)...
            if ~isfield(init,'K') | ~isfield(init,'D')                
                K = zeros(N2,N2);   %conductancias
                D = zeros(N2,N2);   %primeros vecinos
                for nodo=1:N2
                    for vec=nodo:N2 
                        [inod,jnod]=ind2sub([N,M],nodo); %indices nodo
                        [ivec,jvec]=ind2sub([N,M],vec);  %indices vecino
                        if ((ivec==inod && abs(jvec-jnod)==1) || (jvec==jnod && abs(ivec-inod)==1))%primeros vecinos
                            if (I(inod,jnod)==2 && I(ivec,jvec)==2 ) || ... %los dos son bordes
                               (I(inod,jnod)==0 && I(ivec,jvec)==2 ) || ... %uno es borde y el otro esta adentro.
                               (I(inod,jnod)==2 && I(ivec,jvec)==0 )
                                K(nodo,vec)=2;
                            else
                                K(nodo,vec)=rand;
                            end
                            %si aca algunos son cero, ya no varian
                            D(nodo,vec)=1;%primeros vecinos
                        end
                    end
                end
            else
                K = zeros(N2,N2);   %conductancias
                D = init.D;
                K(D==1)=rand(sum(sum(D==1)),1);                
            end
            % ... y simetrica (K_ij=K_ji)
            K=triu(K)+triu(K)'-diag(diag(K)); %GROSO!
            D=triu(D)+triu(D)'-diag(diag(D)); %primeros vecinos  
            %normalizo K para que sum(k^gamma) sea N^2
            K=K.*(N2/sum(K(:).^gamma))^(1/gamma);            
        end                        
        function I2=calculocorrientesR(init)
            %defino constantes
            N=init.N;
            M=init.M;
            
            if isfield(init,'nodosnulos')
                N2=N*M-length(init.nodosnulos); 
            else
                N2=N*M;
            end
            KD=init.K.*init.D;
                        
            %Construyo la matriz C a partir de la matriz K
            C=-KD+diag(sum(KD));
            %esta sobredeterminado, tiro una de las ecuaciones
            C=C(1:N2-1,1:N2-1);    

            %invierto la matriz C 
            R=inv(C);   
                        
            corrcurr=init.corrcurr;

            % Reconstruye correlaciones entre potenciales (N2-1xN2-1)
            uu=C\corrcurr*R';  %es lo mismo que R*corrcurr*R' pero matlab me sugeria hacer esto.
%             uu=R*corrcurr*R';  %es lo mismo que R*corrcurr*R' pero matlab me sugeria hacer esto.

%             C\corrcurr*R'-C\corrcurr*R'

            % Reconstruye las corrientes cuadrticas medias, N2xN2   
            I2=repmat(diag(uu)',N2-1,1)+repmat(diag(uu),1,N2-1)-2*uu;
            I2=[[I2 diag(uu)]; [diag(uu)' 0]];
            I2=I2.*KD.*KD;
            
            if min(I2(:))<0
                fprintf('chan corrientes negativas... min=%g en calculocorrientesR\n',min(I2(:)))
%                  I2(I2<0)=0;
%                 I2=abs(I2);
%                 keyboard
            end
                
        end        
        function [init, status] = unpasoR(init)
            persistent tlast
            if isempty(tlast)
                tlast=tic;
            end            
            
            status=1;
            
            %defino constantes
            N=init.N;
            M=init.M;
            N2=N*M;
            gamma=init.gamma;
            KK=N2^(1/gamma);

            %calculo valor medio de las corrientes corrientes cuadraticas
            I2=fun_circulacion.calculocorrientesR(init);
            if min(I2(:))<0
%                 fprintf('chan corrientes negativas... en calculocorrientesR\n')
                status=0;
            end
            
            
            I2sum=nansum((I2(:)./init.D(:)).^(gamma/(1+gamma)));
                        
            if ~isreal(I2sum)
                %fprintf('Parte imaginaria de I2sum: %g, angulo: %g rad en unpasoR\n',imag(I2sum),angle(I2sum))
                I2sum=real(I2sum);
                status=0;
            end
            
            % actualizo las conductividades
            K=((I2./init.D).^(1/(1+gamma)))/(I2sum^(1/gamma))*KK;
            
            K(isnan(K))=0;
            
            K=triu(K)+triu(K)'-diag(diag(K)); %simetrizo. Sin, esto, se acumula asimetria en K y a la larga, explota (deja de ser inversible)
            
            %normalizo K para que sum(k^gamma) sea N^2
            K=K.*(N2/sum(K(:).^gamma))^(1/gamma);
            
            init.K=K;
            
%             %guardo info de cada paso            
%             indloop=length(init.step)+1;
%             init.step(indloop).potenciadisipada=sum(nansum(I2./K));%ec 1 de corson
%             init.step(indloop).maxK=max(K(:));
%             init.step(indloop).medianK=median(K(K>0));
%             init.step(indloop).nnoceros=sum(K(:)>0);
%             init.step(indloop).toc=toc-tlast;
%             init.step(indloop).maxI2=max(I2(:));
%             init.step(indloop).medianI2=median(log10(I2(I2>0)));            
            
            init.potenciadisipada=sum(nansum(I2./K));%ec 1 de corson
            
            tlast=toc;
        end         
        function [out,status]=potenciadisipadaR(init)
            I2=fun_circulacion.calculocorrientesR(init);
            out=nansum(nansum(I2./init.K));
            status=min(I2(:))>=0;%status=1 si todo ok, status=0 si fallo
        end                        
        function init=calculaCorrCurrR(init)
            N=init.N;
            M=init.M;            

            N2=N*M;            

            distribucioncorrientes=init.distribucioncorrientes;
            %armo meancurrs y sigmacurrs, las corrientes medias y fluctiaciones de las corrientes inyectadas en cada nodo 
            switch distribucioncorrientes
                case 'default'
                    meancurrs=ones(N2-1,1);%valor medio de la corriente de cada nodo
                    sigmacurrs=ones(N2-1,1);%fluctuacion de la corriente de cada nodo    
                case 'rio'
                    meancurrs=[100 ;zeros(N2-2,1)];%valor medio de la corriente de cada nodo
                    sigmacurrs=ones(N2-1,1);%fluctuacion de la corriente de cada nodo        
                case 'dossumideros'
                    meancurrs=[-(N2-1)/2 ;ones(N2-2,1)];%valor medio de la corriente de cada nodo
                    sigmacurrs=ones(N2-1,1);%fluctuacion de la corriente de cada nodo        
                case 'unafuente'
                    meancurrs=ones(N2-1,1);%valor medio de la corriente de cada nodo
                    posx=round(N/2);posy=round(M/2);
                    meancurrs(sub2ind([N,M],posx,posy))=-sum(meancurrs);
                    sigmacurrs=0.0001*ones(N2-1,1);%fluctuacion de la corriente de cada nodo    
                case 'unafuentedossumideros'
                    meancurrs=ones(N2-1,1);%valor medio de la corriente de cada nodo
                    posx=1;posy=1;
                    meancurrs(sub2ind([N,M],posx,posy))=200;
                    posx=N;posy=1;
                    meancurrs(sub2ind([N,M],posx,posy))=200;
                    posx=round(N/2);posy=M;
                    meancurrs(sub2ind([N,M],posx,posy))=-sum(meancurrs(:));
                    sigmacurrs=ones(N2-1,1);%fluctuacion de la corriente de cada nodo                    
                case 'surco'
                    ratio=init.ratio;
                    meancurrs=zeros(N2-1,1);%valor medio de la corriente de cada nodo
                    posx=1:N-1;posy=M*ones(1,N-1);%las de arriba
                    meancurrs(sub2ind([N,M],posx,posy))=1;
                    posx=1:N-1;posy=ones(1,N-1);%las de abajo
                    meancurrs(sub2ind([N,M],posx,posy))=1;
                    posx=ones(1,M-1);posy=1:M-1;%las de la izquierda
                    meancurrs(sub2ind([N,M],posx,posy))=1;  
                    posx=N;posy=1;
                    
                    mycurr=sum(meancurrs(:)); %suma de salidas chiquitas 
                    
                    %version vieja, escrita en fcn del ratio entre salidas
%                     ratiosalidagrande=2;%salidagrande/salidachica
%                     meancurrs(sub2ind([N,M],posx,posy))=ratiosalidagrande*mycurr;%la salida grande
                    
                    %tal vez queremos reescribir esto en terminos de ratio
                    %entre entrada y salida grande (el resto se va en salidas chicas).
                    % E es la entrada
                    % S es la salida grande (S=E*r)
                    % r=S/E es la fraccion de lo que sale por el tubo grande sobre lo que entra
                    % mycurr=E*(1-r) es lo que sale sumado por los tubitos chiquitos
                    % mycurr=E*(1-r)  =>   E=mycurr/(1-r)  => S=E*r=mycurr*r/(1-r)
                    
%                     ratio=.5; %salida grande dividido entrada
                    meancurrs(sub2ind([N,M],posx,posy))=mycurr*ratio/(1-ratio);%la salida grande
                    
                    %normalizo 
                    meancurrs=meancurrs/sum(meancurrs(:));
                    
                    sigmacurrs=1e-8*ones(N2-1,1);%fluctuacion de la corriente de cada nodo                        
                case 'dosvasos'                    
                    meancurrs=zeros(N2-1,1);%valor medio de la corriente de cada nodo
                    posx=ones(1,M-2);posy=2:M-1;%las de la izquierda
                    meancurrs(sub2ind([N,M],posx,posy))=10000;  
                    posx=N*ones(1,M-2);posy=2:M-1;%las de la derecha
                    meancurrs(sub2ind([N,M],posx,posy))=10000;  
                    
                    %X    X
                    %.    .
                    %.    .
                    %.    .
                    %.    .
                    %.    .
                    %o    o
                    
                    %X ENTRADAS
                    %. salidas chiquitas
                    %o salidas grandes
                    
                    mycurr=sum(meancurrs(:))/2; %suma de salidas chiquitas de un lado
                    
                    ratiosalidagrande=1;%salidagrande/salidachica
                    
                    posx=1;posy=1;%abajo izda: o
                    meancurrs(sub2ind([N,M],posx,posy))=ratiosalidagrande*mycurr;
                    posx=1;posy=M;%arriba izda: X
                    meancurrs(sub2ind([N,M],posx,posy))=-(1+ratiosalidagrande)*mycurr;
                    posx=N;posy=1;%abajo dcha: o
                    meancurrs(sub2ind([N,M],posx,posy))=ratiosalidagrande*mycurr;
                    
                    sigmacurrs=0.001*ones(N2-1,1);%fluctuacion de la corriente de cada nodo                        
                case 'casoreal_2in_2out'
                    ratio=init.ratio;
                    ratio_arriba_abajo=init.ratio_arriba_abajo;
                    fraccion_rojo_amarillo=1-ratio_arriba_abajo;%0.4
                    fraccion_azul_verde=ratio_arriba_abajo;%0.6
                    %inicializo de NxM y despues elimino el ultimo por redundante
                    meancurrs=zeros(N2,1);
                    
                    corrientenegritos=1;%corriente en los nodos del borde                    
%                     ratiosalidagrande=3;%salidagrande/salidachica
                    
                    [posx,posy]=find(init.I==2);%negro, borde, sale poquita corriente
                    nnegros=length(posx);
                    meancurrs(sub2ind([N,M],posx,posy))=corrientenegritos; %sale poquito
                    
                    mycurr=nnegros*corrientenegritos; %suma de salidas chiquitas                    
                    [posx,posy]=find(init.I==4);%amarillo, sale 0.4*0.7=0.28
                    n=length(posx);
                    meancurrs(sub2ind([N,M],posx,posy))=mycurr*ratio/(1-ratio)*fraccion_rojo_amarillo/n;

                    [posx,posy]=find(init.I==6);%verde, sale 0.6*0.7=0.42
                    n=length(posx);
                    meancurrs(sub2ind([N,M],posx,posy))=mycurr*ratio/(1-ratio)*fraccion_azul_verde/n;
                    
                    mycurr=sum(meancurrs(:)); %suma de todas las salidas
                    [posx,posy]=find(init.I==3);%rojo, entra 0.4 de todo
                    n=length(posx);
                    meancurrs(sub2ind([N,M],posx,posy))= -mycurr*fraccion_rojo_amarillo/n;%entra todo

                    [posx,posy]=find(init.I==5);%azul: entra 0.6 de todo
                    n=length(posx);
                    meancurrs(sub2ind([N,M],posx,posy))= -mycurr*fraccion_azul_verde/n;%entra todo

                    
                    %1: blanco: nada
                    %2: Negro: sale poquito
                    %3: Rojo: entra 0.4
                    %4: amarillo: sale 0.4*0.7=0.28
                    %5: Azul: entra 0.6
                    %6: verde: sale 0.6*0.7=0.42  
                    
                    %me falta 5 y 6
                    
                    meancurrs(end)=[];%elimino el ultimo, ecuacion redundante
                    
                    sigmacurrs=0.001*ones(N2,1);%fluctuacion de la corriente de cada nodo    
                    [posx,posy]=find(init.I==1);%blanco, no hay corriente
                    sigmacurrs(sub2ind([N,M],posx,posy))= 0;%desconectados
                    sigmacurrs(end)=[];%elimino el ultimo, ecuacion redundante
                case 'casoreal_1in_2out'                    
                    ratio=init.ratio;
                    ratio_arriba_abajo=init.ratio_arriba_abajo;
                    sigmacurr=init.sigmacurrs;
                    fraccion_rojo_amarillo=1-ratio_arriba_abajo;%0.4
                    fraccion_azul_verde=ratio_arriba_abajo;%0.6
                    %inicializo de NxM y despues elimino el ultimo por redundante
                    meancurrs=zeros(N2,1);
                    
                    corrientenegritos=1;%corriente en los nodos del borde                    
%                     ratiosalidagrande=3;%salidagrande/salidachica
                    
                    [posx,posy]=find(init.I==2);%negro, borde, sale poquita corriente
                    nnegros=length(posx);
                    meancurrs(sub2ind([N,M],posx,posy))=corrientenegritos; %sale poquito
                    
                    mycurr=nnegros*corrientenegritos; %suma de salidas chiquitas                    
                    [posx,posy]=find(init.I==4);%amarillo, sale 0.4*0.7=0.28
                    n=length(posx);
                    meancurrs(sub2ind([N,M],posx,posy))=mycurr*ratio/(1-ratio)*fraccion_rojo_amarillo/n;

                    [posx,posy]=find(init.I==6);%verde, sale 0.6*0.7=0.42
                    n=length(posx);
                    meancurrs(sub2ind([N,M],posx,posy))=mycurr*ratio/(1-ratio)*fraccion_azul_verde/n;
                    
                    mycurr=sum(meancurrs(:)); %suma de todas las salidas
                    [posx,posy]=find(init.I==3);%rojo, entra todo
                    n=length(posx);
                    meancurrs(sub2ind([N,M],posx,posy))= -mycurr/n;%entra todo
                    
                    %1: blanco: nada
                    %2: Negro: sale poquito
                    %3: Rojo: entra todo
                    %4: amarillo: sale 0.4*0.7=0.28
                    %6: verde: sale 0.6*0.7=0.42  
                    
                    %me falta 5 y 6
                    
                    meancurrs(end)=[];%elimino el ultimo, ecuacion redundante
                    
                    sigmacurrs=1e-4*ones(N2,1);%fluctuacion de la corriente de cada nodo    
                    [posx,posy]=find(init.I==1);%blanco, no hay corriente
                    sigmacurrs(sub2ind([N,M],posx,posy))= 0;%desconectados
                    [posx,posy]=find(init.I==2);%negros , sale pocquito
                    sigmacurrs(sub2ind([N,M],posx,posy))= sigmacurr;%desconectados
                    sigmacurrs(end)=[];%elimino el ultimo, ecuacion redundante                    
            end

            %calculo la matriz de correlaciones entre corrientes inyectadas <ik*il>
            init.meancurrs=meancurrs;
            init.sigmacurrs=sigmacurrs;
            init.corrcurr=meancurrs*meancurrs'+diag(sigmacurrs);
            %la corriente del ultimo nodo no se pone, y su potencial vale cero.          
            
            init.meancurrsnodos=reshape([init.meancurrs; -sum(init.meancurrs(:))],[N,M])';
            
        end        
        function inits=topologia(init)

            Nloops=init.Nloops;
            Niteraciones=init.Niteraciones;

            % Conectividad a primeros vecinos (inicia random)...
            [init.K,init.D]=fun_circulacion.KPrimerosVecinosR(init);
            % [init.K,init.D]=fun_circulacion.KRedCuadradaDiagonalesR(init);

            %inicializo inits
            inits=init;
            inits.potenciadisipada=inf;
            inits.param=nan;
            inits.meanparam=nan;
            inits.maxparam=nan;
%             inits.thresholdK=nan;
%             inits.anastomo=nan;
            inits(Niteraciones).N=init.N;

            tic
%             figure(1);clf;hold all
            fprintf('\b\t%4d/%4d',0,Niteraciones);   
            for indit=1:Niteraciones
                try
%                     lastwarn(''); % Clear last warning message
                    [init.K,init.D]=fun_circulacion.KPrimerosVecinosR(init);
                    init.potenciadisipada=inf;%inicializo
                    
                    initprev=init;
                    init=fun_circulacion.muchospasosR(init);
                    
                    if ~isreal(init.potenciadisipada)
                        fprintf('potencia compleja... en topologia\n')
%                         keyboard
                    end
                    
%                     for indloop=1:Nloops        
%                         % un paso
%                         init=fun_circulacion.unpasoR(init);    
%                     end    
                    
%                     if isempty(lastwarn)%only if no warning 
                        
                        fprintf('\b\b\b\b\b\b\b\b\b%4d/%4d',indit,Niteraciones);   
%                         fprintf('%d/%d\t%2.2fs\tp=%2.5f\n',indit,Niteraciones,toc,log10(init.potenciadisipada));   
                        init.param=fun_circulacion.Parametro2(init);
                        init.meanparam=mean(init.param);
                        init.maxparam=max(init.param);                        
                        
% %                         % busco iterativamente el umbral de K que me
% %                         % alimenta solo los nodos con corriente neta
% %                         init=fun_circulacion.buscothresholdKbiparticion(init);
% %                         K=init.K;        
% %                         K(K<init.thresholdK)=0;
% %                         G=graph(K,'upper');
% %                         init.anastomo=~isinf(G.distances(1,end));
% %                         if init.anastomo
% %                             figure(200);clf
% %                             fun_circulacion.plot_meshR(log10(K+1),init); %log para mirarte mejor        
% % %                             keyboard
% %                         end
                        inits(indit)=init;
                        
%                     end
                catch ME                    
                    ME
                    disp('OOPS error aca..')
%                     isreal(init.K)
%                     keyboard
                end                
            end
            
            %dibujito
            [~,indglobal]=min([inits.potenciadisipada]);
            init=inits(indglobal);
            tplot=tic;       
            cla;hold all
            try
                fun_circulacion.plot_meshR(log10(init.K+1),init); %log para mirarte mejor        
                %fun_circulacion.plot_meshR(init.K,init); %log para mirarte mejor                        
            catch ME
                ME
            end                        
            str=sprintf('mean:%2.3f  max:%2.3f  pot:%2.3f',init.meanparam,init.maxparam,log10(init.potenciadisipada));
            title(str)    
%             init.param
            fprintf('\ttplot: %2.2fs\n',toc(tplot));                    
            drawnow                    
        end
        function init=muchospasosR(init)
            if ~isfield(init,'potenciadisipada')
                disp('falta campo potenciadisipada')
                return
            end
            indloop=0;
            while 1 
                indloop=indloop+1;
                if indloop>1000;break;end
                % un paso
                try
                    prevpot=init.potenciadisipada;
                    previnit=init;
                    [init, status] = fun_circulacion.unpasoR(init);    

                    if ~isreal(init.potenciadisipada) || status==0 || init.potenciadisipada==0
%                         fprintf('potencia compleja ... en muchospasosR\n')
                        init=previnit;
                        break
%                         keyboard
                    end                    
                    
                    deltapot=prevpot-init.potenciadisipada;
%                      fprintf('%f\n',deltapot)
                    if deltapot<0
                        break
                    end
                catch ME
                    ME
%                     keyboard
                end            
            end   
            init.Nloops=indloop;
        end
        function init=SumoKBordes(init,val)
            N=init.N;
            M=init.M;

            posx1=1:N-1;posy1=ones(1,N-1);
            posx2=2:N;posy2=ones(1,N-1);
            for ind=1:length(posx1)
                i1=sub2ind([N,M],posx1(ind),posy1(ind));
                i2=sub2ind([N,M],posx2(ind),posy2(ind));
                init.K(i1,i2)=val;
                init.K(i2,i1)=val;
            end

            posx1=ones(1,M-1);posy1=1:M-1;
            posx2=ones(1,M-1);posy2=2:M;
            for ind=1:length(posx1)
                i1=sub2ind([N,M],posx1(ind),posy1(ind));
                i2=sub2ind([N,M],posx2(ind),posy2(ind));
                init.K(i1,i2)=val;
                init.K(i2,i1)=val;
            end

            posx1=1:N-1;posy1=M*ones(1,N-1);
            posx2=2:N;posy2=M*ones(1,N-1);
            for ind=1:length(posx1)
                i1=sub2ind([N,M],posx1(ind),posy1(ind));
                i2=sub2ind([N,M],posx2(ind),posy2(ind));
                init.K(i1,i2)=val;
                init.K(i2,i1)=val;
            end

            posx1=N*ones(1,M-1);posy1=1:M-1;
            posx2=N*ones(1,M-1);posy2=2:M;
            for ind=1:length(posx1)
                i1=sub2ind([N,M],posx1(ind),posy1(ind));
                i2=sub2ind([N,M],posx2(ind),posy2(ind));
                init.K(i1,i2)=val;
                init.K(i2,i1)=val;
            end            
        end
               
        %Caso Real
        function init=inicializoConImagen(imfname,distribucioncorrientes,ratio_out_in,ratio_arriba_abajo,sigmacurrs,corrientesinicial)
            
            
            I=imread(imfname);

            indexB    =I(:,:,1)==255 & I(:,:,2)==255 & I(:,:,3)==255;%blanco
            indexN    =I(:,:,1)==0 & I(:,:,2)==0 & I(:,:,3)==0;%negro
            indexR    =I(:,:,1)==255 & I(:,:,2)==0 & I(:,:,3)==0;%rojo
            indexA    =I(:,:,1)==255 & I(:,:,2)==255 & I(:,:,3)==0;%amarillo
            indexAzul =I(:,:,1)==0 & I(:,:,2)==0 & I(:,:,3)==255;%amarillo
            indexVerde=I(:,:,1)==0 & I(:,:,2)==255 & I(:,:,3)==0;%amarillo
            
            %1: blanco: nada
            %2: Negro: sale poquito
            %3: Rojo: entra 0.4
            %4: amarillo: sale 0.4*0.7=2.8
            %5: Azul: entra 0.6
            %6: verde: sale 0.6*0.7=4.2            
            
            I4v=indexB+2*indexN+3*indexR+4*indexA+indexAzul*5+indexVerde*6;     
            I=I4v';
           
            
            init=[];
            init.I=I;
            init.Nloops=100;
            init.Niteraciones=100;
            gamma=0.5;   % cables elctricos (gamma=1), flujo de Poiseuille (gamma=1/2)
            init.gamma=gamma;
            init.distribucioncorrientes=distribucioncorrientes;
            init.N=size(I,1);
            init.M=size(I,2);            
            init.ratio=ratio_out_in;
            init.ratio_arriba_abajo=ratio_arriba_abajo;
            init.sigmacurrs=sigmacurrs;
            
            switch corrientesinicial
                case 'random' 
                    [K,D]=fun_circulacion.KPrimerosVecinosR(init);
                case 'bordes'
                    [K,D]=fun_circulacion.KPorLosBordes(init);
            end
            
            %desconecto todos los nodos blancos. pongo en cero todas las filas y columnas
            [xnodos,ynodos]=find(init.I==1);%es blanco, no esta conectado a nada
            inod=sub2ind([init.N,init.M],xnodos,ynodos); %indices nodo
            K(inod,:)=0;
            K(:,inod)=0;
            D(inod,:)=0;
            D(:,inod)=0;
            
            N=init.N;
            M=init.M;
            N2=N*M;            
            %normalizo K para que sum(k^gamma) sea N^2
            K=K.*(N2/sum(K(:).^gamma))^(1/gamma);            
            
            init.K=K;
            init.D=D;
            init=fun_circulacion.calculaCorrCurrR(init);
            
            
        end
        function init=comprimo_elimino_nodos_desconectados(init)
            % comprimo, elimino las filas y columnas de los nodos blancos, desconectados
            init.nodosnulos=find(init.I(:)==1);
            init.K(init.nodosnulos,:)=[];
            init.K(:,init.nodosnulos)=[];
            init.D(init.nodosnulos,:)=[];
            init.D(:,init.nodosnulos)=[];
            init.meancurrs(init.nodosnulos)=[];
            init.sigmacurrs(init.nodosnulos)=[];
            init.corrcurr(init.nodosnulos,:)=[];
            init.corrcurr(:,init.nodosnulos)=[];            
        end
        function init=expando_agrego_nodos_desconectados(init)
            %expando, agrego filas y columnas nulas
            init.K=fun_circulacion.addrowsandcolumnszeros(init.K,init.nodosnulos);
            init.D=fun_circulacion.addrowsandcolumnszeros(init.D,init.nodosnulos);
            init.corrcurr=fun_circulacion.addrowsandcolumnszeros(init.corrcurr,init.nodosnulos);
            init.meancurrs=fun_circulacion.addrowsszeros(init.meancurrs,init.nodosnulos);
            init.sigmacurrs=fun_circulacion.addrowsszeros(init.sigmacurrs,init.nodosnulos);                        
        end
        
        %BARRIDO
        function RES=barrido(datadir,sizestr,variablebarrido,corrientesinicial)
            
            filenameout =sprintf('RES_caso_real_%s_barrido_%s_1entrada_%s_parte2',sizestr,variablebarrido,corrientesinicial);

            
            switch variablebarrido
                case 'sinbarrido'
                    niteraciones=1000;
                    ratios_out_in=repmat(0.7,1,niteraciones);
                    ratios_arriba_abajo=repmat(0.6,1,niteraciones);
                    sigmacurrs=repmat(0.001,1,niteraciones);
                case 'inout' 
%                     niteraciones=1000;
%                     ratios_out_in=.5:.1:.9;ratios_out_in=sort(repmat(ratios_out_in,1,200));
                    niteraciones=800;
                    ratios_out_in=.1:.1:.4;ratios_out_in=sort(repmat(ratios_out_in,1,200));                    
                    ratios_arriba_abajo=repmat(0.6,1,niteraciones);
                    sigmacurrs=repmat(0.001,1,niteraciones);
                case 'updown'
%                     niteraciones=1000;
                    niteraciones=800;
                    ratios_out_in=repmat(0.7,1,niteraciones);
%                     ratios_arriba_abajo=.4:.1:.8;ratios_arriba_abajo=sort(repmat(ratios_arriba_abajo,1,200));
                    ratios_arriba_abajo=[.1 .2 .3 .9];ratios_arriba_abajo=sort(repmat(ratios_arriba_abajo,1,200));
                    sigmacurrs=repmat(0.001,1,niteraciones);
                case 'sigmacurr'
%                     niteraciones=1000;
                    niteraciones=800;
                    ratios_out_in=repmat(0.7,1,niteraciones);
                    ratios_arriba_abajo=repmat(0.6,1,niteraciones);
%                     sigmacurrs=[0.001 0.01 0.1 1 10];sigmacurrs=sort(repmat(sigmacurrs,1,200));
                    sigmacurrs=10.^[2 3 4 5];sigmacurrs=sort(repmat(sigmacurrs,1,200));                    
                otherwise
                    RES=[];
                    return
            end
            
            distribucioncorrientes='casoreal_1in_2out';
            imfname=sprintf('caso_real_%s_1entrada.bmp',sizestr);
            
%             disp('Uso dos entradas y dos salidas!!')
%             distribucioncorrientes='casoreal_2in_2out';
%             imfname=sprintf('caso_real_%s.bmp',sizestr);

            I=imread(imfname);

            t1=tic;
            RES=struct([]);
            out=nan(niteraciones,1);
            out2=nan(niteraciones,1);
            out3=nan(niteraciones,1);
            out4=nan(niteraciones,1);
            color=nan(niteraciones,1);
            for indit=(length(RES)+1):niteraciones

                figure(1);
                subplot(1,2,1)
                image(I)
                xlim([.5 size(I,2)+.5])
                ylim([.5 size(I,1)+.5])
                set(gca,'xcolor','none','ycolor','none')
                set(gca,'color','none')
                axis xy
                axis equal    

                ratio_out_in=ratios_out_in(indit);%.7
                ratio_arriba_abajo=ratios_arriba_abajo(indit);%.6
                sigmacurr=sigmacurrs(indit);
                init=fun_circulacion.inicializoConImagen(imfname,distribucioncorrientes,ratio_out_in,ratio_arriba_abajo,sigmacurr,corrientesinicial);
                init.sigmacurr=sigmacurr;

                % comprimo, elimino las filas y columnas de los nodos blancos, desconectados
                init2=fun_circulacion.comprimo_elimino_nodos_desconectados(init);
                init2.potenciadisipada=fun_circulacion.potenciadisipadaR(init2);
                init2=fun_circulacion.unpasoR(init2);
                init2=fun_circulacion.muchospasosR(init2);

                %expando, agrego filas y columnas nulas, para graficar
                init=fun_circulacion.expando_agrego_nodos_desconectados(init2);

                init3=init;
                init3.K=sparse(init.K);
                init3.D=sparse(init.D);    
                init3.corrcurr=sparse(init.corrcurr);
                RES(indit).init=init3; 

                K=init.K;        
                subplot(1,2,2);cla
            %     [G,p]=fun_circulacion.plot_meshR(log10(K+1),init); %log para mirarte mejor 
                [G,p]=fun_circulacion.plot_meshR(K,init); %log para mirarte mejor 
                xlim([.5 size(init.I,1)+.5])
                ylim([.5 size(init.I,2)+.5])
                set(gca,'xcolor','none','ycolor','none')
                set(gca,'color','none')

                hold all
                [distancia,rowbifu,colbifu,rowin,colin]=fun_circulacion.calculo_bifurcacion(init);
% %                 scatter(rowin,colin,10,'b','filled')
% %                 scatter(rowin,colin,100,'b')
% %                 scatter(rowin,colin,300,'b')    
% %                 scatter(rowbifu,colbifu,10,'k','filled')
% %                 scatter(rowbifu,colbifu,100,'k')
% %                 scatter(rowbifu,colbifu,300,'k')

                figure(2);clf
                out(indit)=distancia;
                out2(indit)=init.potenciadisipada;
                color(indit)=init.sigmacurr;
                scatter(out,out2,10,color,'filled')
                xlabel('distancia')
                ylabel('potenciadisipada')

                [nloops,nnodes,nedges]=fun_circulacion.number_of_loops_euler(init);
%                 nedgesnorm=sum(full(init.D(:))>0)/2;
%                 nnodesnorm=sum(sum(init.D)>0);
%                 nloopsnorm=1+nedgesnorm-nnodesnorm;
                figure(3);clf
                out3(indit)=nloops;
                scatter(out3,out2,10,color,'filled')
                xlabel('nloops')
                ylabel('potenciadisipada')
                
                figure(4);clf
                out4(indit)=max(init.K(:));
                scatter(out4,out2,10,color,'filled')
                xlabel('max(k)')
                ylabel('potenciadisipada')                
                
                drawnow        
                fprintf('%d/%d %2.1fsec\n',niteraciones,indit,toc(t1))

            %     out(indit)=max(full(K(:)));
            %     fprintf('%d/%d %2.1fsec maxk:%2.2f frac anastomo:%g%%\n',niteraciones,indit,toc(t1),max(full(K(:))),100*mean(out(not(isnan(out)))>75))
            %     
            %     figure(2);clf
            %     subplot(2,1,1)
            % %     a=sort(out);
            %     [h,x]=hist(out,100);
            %     plot(x,cumsum(h),'.-')
            %     title(mean(out(not(isnan(out)))>75)*100)
            % 
            %     subplot(2,1,2)
            %     hist(out,100)

                if mod(indit,100)==0
                   save([datadir filenameout], 'RES')
                end
            end
            save([datadir filenameout], 'RES')
        end
        function INIT=agrego_nloops_bifurcacion(INIT) 
            fprintf('\n0000\n')
            for ind=1:length(INIT)
                init=INIT(ind);
                K=full(init.K);
            %     K(K>0)=1;
                [nloops,nnodes,nedges]=fun_circulacion.number_of_loops_euler(init);
                INIT(ind).nloops=nloops;
                INIT(ind).nnodes=nnodes;
                INIT(ind).nedges=nedges;
                [distancia,rowbifu,colbifu,rowin,colin]=fun_circulacion.calculo_bifurcacion(init);
                INIT(ind).distancia=distancia;
                INIT(ind).bifurcation=[rowbifu; colbifu];
                fprintf('\b\b\b\b\b\b%5d\n',ind)
            end
        end
        
        %bifurcacion
        function [distancia,rowbifu,colbifu,rowin,colin]=calculo_bifurcacion(init)
            [rowin,colin]=find(init.I==3);%posicion del nodo de entrada

            a=sort(init.K);%ordeno cada columna
            
            data=a(end-2,:);%me quedo con el tercer link mas grande de cada nodo
            
            %para el nodo de entrada, en lugar del tercero, me quedo con es segundo
            indin=sub2ind([init.N,init.M],rowin,colin);
            data(indin)=a(end-1,indin);
            
            [~,indmax]=max(data);%me fijo en cada columna el antepenultimo, 
            %que corresponde al tercer link mas grande de cada nodo
            %y me quedo con el maximo de todos
            [rowbifu,colbifu]=ind2sub([init.N,init.M],indmax);

            distancia=abs(rowbifu-rowin)+abs(colbifu-colin);
        end        
        
        %loops
        function K=remove_pass_throw_nodes(K)
            %remove pass-throw nodes, iteratively
            while 1
                nodestoberemoved=find((sum(K>0)==2));  %los que tienen dos conecatdos
                nodesreallyremoved=0;
                if sum(nodestoberemoved)>0
                    for indn=length(nodestoberemoved):-1:1%recorro de atras padelante
                        node=nodestoberemoved(indn);
                        extremos=find(K(:,node));%los dos nodos a los que se conecta
                        source=extremos(1);
                        dest=extremos(2);
                        if K(source,dest)==0 %si no estan conectados entre ellos, 
                            %los conecto y elimino el nodo. pues si estan conectados
                            %tengo un loop de 3, que no quiero cortar
                            nodesreallyremoved=nodesreallyremoved+1;
                            value=(K(source,node)+K(dest,node))/2;
                            K(source,dest)=value;
                            K(dest,source)=value;
                            K(:,node)=0;
                            K(node,:)=0;            
                        end
                    end
                else
                    break
                end
                if nodesreallyremoved == 0 %si en esta pasada no elimine ninguno, salgo
                    %pues tengo loop de 3 nodos, tengo nodos con 2 conectados, 
                    %pero no puedo eliminar nada
                    break
                end    
            end
        end
        function K=remove_single_ended_nodes(K)
        %remove single ended nodes, iteratively            
            while 1
                nodestoberemoved=sum(K>0)==1;%los qeu tienen un solo conectado
                if sum(nodestoberemoved)>0
                    K(:,nodestoberemoved)=0;
                    K(nodestoberemoved,:)=0;
                else
                    break
                end
            end
        end     
        function [nloops,nnodes,nedges]=number_of_loops_euler(init)
            K=init.K;
            
            K=sparse(K);%esto hizo que lo de mas abajo sea 5 veces mas rapido
            
            %desconecto los K menores que un umbral. y eligo el umbral para que todos
            %los nodos sumideros queden conectados:
            %-para cada nodo sumidero, busco la conexion maxima. 
            %-me quedo con el minimo de esos de todos los nodos. 
            %-lo divido por 1.1, por las fluctuaciones...
            index=(init.meancurrs~=0);%todos los sumideros (tejido, los que tienen corriente media no nula)
            kmax=full(max(K(index,:),[],2));            
            umbral=min(kmax)/1.1;                        
            K(K<umbral)=0;
            K(K>0)=1;
                        
            K=fun_circulacion.remove_single_ended_nodes(K);
%             K=fun_circulacion.remove_pass_throw_nodes(K);


            nnodes=full(sum(sum(K)>0));
            nedges=full(sum(K(:)>0)/2);
            if nedges==0 && nnodes==0
                nloops=0;
            else
                nloops=1+nedges-nnodes;
            end
        end
               
        function param=Parametro2(init)
            N=init.N;
            M=init.M;
            K=init.K;
            
            param=nan(1,M-1);
            for indy=1:M-1%para cada fila miro las conexiones verticales
                posx=1:N;
                posy=indy*ones(1,N);
                nododesde=sub2ind([N,M],posx,posy);%los nodos de una fila
                nodohasta=sub2ind([N,M],posx,posy+1);%los nodos de una fila mas arriba
                pesos=K(sub2ind([N*M N*M],nododesde,nodohasta));%ancho de los cables verticales en la fila indy-esima
                [~,indmax]=max(pesos);
%                 param(indy)=N-indmax+1;
                param(indy)=((N-1)-(indmax-1))/(N-1);% 0=superficial 1=llega al fondo

                
%                 pesos=pesos/sum(pesos)*N;%normalizo los pesos
%                 param(indy)=mean( pesos .* posx);%promedio pesado
            end
        end        
        function C=addrowsandcolumnszeros(m,rcs2add)
%             m
%             for ind=1:length(rcs2add)   
%                 rc2add=rcs2add(ind);
%                 m=[m(1:rc2add-1,:); zeros(1,size(m,2)) ;m(rc2add:end,:)];%agrego fila
%                 m=[m(:,1:rc2add-1,:) zeros(size(m,1),1) m(:,rc2add:end)];%agrego columna
%             end         
            
            T          = true(size(m,1)+numel(rcs2add),1);
            T(rcs2add) = false;
            B          = zeros(numel(T), size(m,2));
            B(T,:)     = m;
            
            T          = true(size(B,2)+numel(rcs2add),1);
            T(rcs2add) = false;
            C          = zeros(numel(T), size(B,1));
            C(:,T)     = B;            
            
            
            
%             https://la.mathworks.com/matlabcentral/answers/435712-how-to-insert-rows-into-a-matrix
%             m = rand(748, 6);  % Test data
%             n          = 3;  % In each 3rd row
%             T          = true(748 / (n-1) * n, 1);
%             T(n:n:end) = false;
%             B          = zeros(numel(T), 6);
%             B(T, :)    = m;            
            
            
        end
        function m=addrowsszeros(m,rcs2add)
            for ind=1:length(rcs2add)   
                rc2add=rcs2add(ind);
                m=[m(1:rc2add-1,:); zeros(1,size(m,2)) ;m(rc2add:end,:)];%agrego fila                
            end                        
        end        
        
        function report_ttest2(y1,y2,namey1,namey2)
            y1=y1(~isnan(y1));
            y2=y2(~isnan(y2));
            [h p ci s]=ttest2(y1,y2);
            fprintf('%s vs %s\tt(%d)=%f\tp=%f\tY1(%d)=%0.2f(%0.2f)\tY2(%d)=%0.2f(%0.2f)\t(SE)\n',namey1,namey2,s.df,s.tstat,p,length(y1),mean(y1),std(y1)/sqrt(length(y1)),length(y2),mean(y2),std(y2)/sqrt(length(y2)));
            %fprintf('%s vs %s\tt(%d)=%f\tp=%f\tY1=%f(%f)\tY2=%f(%f)\t(SD)\n',namey1,namey2,s.df,s.tstat,p,mean(y1),std(y1),mean(y2),std(y2));
        end                
    end
end

