%% Code for generating figures of the paper
clear all
datadir='c:\temp\datadir\';

corrientesiniciales={'bordes' 'random'};
barridos={'inout' 'updown' 'sigmacurr'};
variablesbarrido={'ratio'  'ratio_arriba_abajo' 'sigmacurr'};
variablesbarrido2={'Out/In ratio'  'Up/(Up+Down) ratio' 'Current sdev (log_{10})'};
sizes={'27x21' '40x34' '68x60' '90x80' '90x80'};
maxdistance=[1 1 1 sum([89 79]-[17 0]) sum([89 79]-[17 0])];
tic
cont=0;
close all
for indsize=5%:length(sizes)
    for indbarrido=1:length(barridos)
        for indcorrini=2%1:length(corrientesiniciales)
            sizestr=sizes{indsize};        
            barrido=barridos{indbarrido};
            variablebarrido=variablesbarrido{indbarrido};
            variablebarrido2=variablesbarrido2{indbarrido};
            corrientesinicial=corrientesiniciales{indcorrini};
            cont=indsize+10*indbarrido;
            
            if indsize<5
                filenamein  = sprintf('RES_caso_real_%s_barrido_%s_1entrada_%s_calc',sizestr,barrido,corrientesinicial);
                load([datadir filenamein])
            else %cargo en dos partes
                %cargo primera parte
                filenamein  = sprintf('RES_caso_real_%s_barrido_%s_1entrada_%s_calc.mat',sizestr,barrido,corrientesinicial);
                temp=load([datadir filenamein]);
                RES1=temp.RES;
                %cargo segunda parte
                filenamein  = sprintf('RES_caso_real_%s_barrido_%s_1entrada_%s_parte2_calc.mat',sizestr,barrido,corrientesinicial);
                temp=load([datadir filenamein]);
                RES2=temp.RES;                
                RES=[RES1 RES2];
            end
            

            signo=(indcorrini-1.5)*2;
            figure(cont);
            
            x=[RES.(variablebarrido)];
            if strcmp(variablebarrido,'sigmacurr')
                h=subplot(2,1,1);hold all
                x=log10(x);          

                hh=boxplot([RES.nloops],x,'symbol','.w');
                for i=1:9
                    set(hh(1,i),'LineStyle','-')
                    set(hh(2,i),'LineStyle','-')
                    set(hh(7,i),'MArker','none')
                end                

                ylabel('Loops')
                pos=get(h,'position');
                set(h,'position',[.14 .59 .77 .4]);
                ylim([-1 max(ylim)])
                
                if indbarrido==3
                    report_ttest2(data(x<0),data(x>0),'pre','pos');
                end                      
                
            end            

            h=subplot(2,1,2);hold all   
            x=[RES.(variablebarrido)];
            if strcmp(variablebarrido,'sigmacurr')
                x=log10(x);
            end                                  
                    
            data=[RES.distancia]/maxdistance(indsize);
            hh=boxplot(data,x,'symbol','.w');
            for i=1:9
                set(hh(1,i),'LineStyle','-')
                set(hh(2,i),'LineStyle','-')
                set(hh(7,i),'MArker','none')
            end
            
            if indbarrido==1                
                fun_circulacion.report_ttest2(data(x<.5),data(x>.5),'pre','pos');
            end
            
            if indbarrido==2                
                fun_circulacion.report_ttest2(data(x<.25),data(x>.25 & x<.75),'x<.25','medio');                    
                fun_circulacion.report_ttest2(data(x>.25 & x<.75),data(x>.75),'medio','x>.75');                    
            end             
            
            if indbarrido==3
                fun_circulacion.report_ttest2(data(x<0),data(x>0),'pre','pos');               
            end
            
            xlabel(variablebarrido2);%,'interpreter','none')
            ylabel('Distance')
            pos=get(h,'position');
            set(h,'position',[.14 .59-.4 .77 .4]);                        
            ylim([0 max(ylim)])
            set(gcf,'position',[680   558   240   180])
            
            switch indbarrido
                case 1
                    indices=[1001 1000];
                case 2
                    indices=[1002 1800];
                case 3
                    indices=[1 1000];
            end                    
            
            for i=[1 2]
                figure(1000+100*indcorrini+indsize+10*indbarrido+10000*i);clf
                
                init=RES(indices(i));
                K=init.K;
                [G, p]=fun_circulacion.plot_meshR((K),init);
                p.EdgeAlpha=1;
                xlim([.5 size(init.I,1)+.5])
                ylim([.5 size(init.I,2)+.5])
                set(gca,'xcolor','none','ycolor','none')
                set(gca,'color','none')                

                %transformo el ancho para que se vea mejor
                oldlw=p.LineWidth;
                p.LineWidth=1+(10-1)*oldlw/10;
                
                hold all
                [distancia,rowbifu,colbifu,rowin,colin]=fun_circulacion.calculo_bifurcacion(init);
                
                str2=sprintf('dist: %d, #loops: %d',distancia,init.nloops);

                fname=sprintf('./outputs/flow_%s_%g.png',variablebarrido,init.(variablebarrido));
                set(gcf,'color','w')
                I=getframe(gca);

            end            
            str=sprintf('%s %s %s',sizestr,barrido,corrientesinicial);
            fprintf('%s %2.2fs\n',str,toc);
        end
    end
end
disp('done')